apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: docker-build-buildah
  namespace: ci
spec:
  params:
  - default: quay.io/buildah/stable
    description: The location of the buildah builder image.
    name: builderimage
    type: string
  - default: ./Dockerfile
    description: Path to the Dockerfile to build.
    name: dockerfile
    type: string
  - default: ""
    description: Forces FROM in Dockerfile.
    name: fromimage
    type: string
  - default: "true"
    description: Verify the TLS on the registry endpoint (for push/pull to a non-TLS
      registry)
    name: tlsverify
    type: string
  resources:
    inputs:
    - name: source
      type: git
    outputs:
    - name: image
      type: image
  steps:
  - command:
    - /bin/bash
    - -c
    - |
        if test "$(inputs.params.fromimage)"; then \
            REPLACE=`awk '/FROM /{print $2}' "$(inputs.params.dockerroot)/$(inputs.params.dockerfile)" | tail -1`; \
            if echo "$(inputs.params.fromimage)" | grep -E '/.*/' >/dev/null; then \
                WITH="$(inputs.params.fromimage)"; \
            else \
                WITH="registry.registry.svc.cluster.local:5000/ci/$(inputs.params.fromimage)"; \
            fi; \
            sed -i "s|^[ ]*FROM[ ]*$REPLACE[^ ]*$|FROM $WITH|" "$(inputs.params.dockerroot)/$(inputs.params.dockerfile)"; \
        fi; \
        if test "$(inputs.params.forceuid)" -a "$(inputs.params.forceuid)" -gt 0 >/dev/null 2>&1; then \
            if ! grep -E '^USER[ \t]*[0-9]' "$(inputs.params.dockerroot)/$(inputs.params.dockerfile)" >/dev/null; then \
                echo USER $(inputs.params.forceuid) >>"$(inputs.params.dockerroot)/$(inputs.params.dockerfile)"; \
            fi; \
        elif test "$(inputs.params.forceuid)"; then \
            if ! grep -E '^USER[ \t]*[0-9]' "$(inputs.params.dockerroot)/$(inputs.params.dockerfile)" >/dev/null; then \
                echo USER 1000 >>"$(inputs.params.dockerroot)/$(inputs.params.dockerfile)"; \
            fi; \
        fi
    image: $(inputs.params.builderimage)
    name: patch-from
    resources: {}
    securityContext:
      privileged: true
    workingDir: /workspace/source
  - command:
    - buildah
    - bud
    - --squash
    - --tls-verify=$(inputs.params.tlsverify)
    - --layers
    - -f
    - $(inputs.params.dockerfile)
    - -t
    - $(outputs.resources.image.url)
    - .
    env:
    - name: DO_UPGRADE
      value: "true"
    image: $(inputs.params.builderimage)
    name: build
    resources: {}
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /dev/fuse
      name: devfuse
    - mountPath: /var/lib/containers
      name: varlibcontainers
    workingDir: /workspace/source
  - command:
    - buildah
    - push
    - --tls-verify=$(inputs.params.tlsverify)
    - $(outputs.resources.image.url)
    - docker://$(outputs.resources.image.url)
    image: $(inputs.params.builderimage)
    name: push
    resources:
      limits:
        cpu: 400m
        memory: 4Gi
      requests:
        cpu: 200m
        memory: 2Gi
    securityContext:
      privileged: true
    volumeMounts:
    - mountPath: /dev/fuse
      name: devfuse
    - mountPath: /var/lib/containers
      name: varlibcontainers
    workingDir: /workspace/source
  volumes:
  - hostPath:
      path: /dev/fuse
    name: devfuse
  - emptyDir: {}
    name: varlibcontainers
